#ifndef _NET_EXCEPTION_
#define _NET_EXCEPTION_

#include <stdio.h>
#include <string.h>


class NetException
{
public:
	char m_file[255];
	int m_line;
	char m_where[255];
	char m_what[255];
	void *m_arg;
	
	inline NetException(char *file, int line, char *where, char *what, void *arg);
	inline void print(char *s);
};

inline NetException::NetException(char *file, int line, char *where, char *what, void *arg)
{
	memset(m_file, 0, sizeof(m_file));
	memset(m_where, 0, sizeof(m_where));
	memset(m_what, 0, sizeof(m_what));
		
	if(file != 0)
		strncpy(m_file, file, sizeof(m_file) - 1);
	m_line = line;
	if(where != 0)
		strncpy(m_where, where, sizeof(m_where) - 1);
	if(what != 0)
		strncpy(m_what, what, sizeof(m_what) - 1);
	m_arg = arg;
}

#define NET_THROW(x, y) throw NetException(__FILE__, __LINE__, (x), (y), 0)
#define NET_THROW_ARG(x, y, z) throw NetException(__FILE__, __LINE__, (x), (y), (z))

#endif
