#ifndef _PREFERENCES_H_
#define _PREFERENCES_H_

#include <Window.h>
#include <View.h>
#include <CheckBox.h>
#include <Button.h>

const uint32 PREFS_SAVE = 'PrSv';
const uint32 PREFS_CANCEL = 'PrCl';

//-------------------------------------------------------------------------------------------------------

class GenPrefView : public BView 
{
	public:
		GenPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		BCheckBox* BuddyListAllWorkspaces;
		BCheckBox* PlaySounds;
		BCheckBox* UseDeskbar;
		BCheckBox* DoIdleTime;
		bool globalOnly;
};


//-------------------------------------------------------------------------------------------------------

class ConnectionPrefView : public BView 
{
	public:
		ConnectionPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		BTextControl* conHost;
		BTextControl* conPort;
		bool globalOnly;		
};


//-------------------------------------------------------------------------------------------------------

class ChatWindowPrefView : public BView 
{
	public:
		ChatWindowPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		BCheckBox* ChatWindowAllWorkspaces;
		BCheckBox* ChatWindowPopup;
		BCheckBox* ChatFontColorSizes;
		BCheckBox* ChatShowLinks;
		BCheckBox* ChatPrefixNewMessages;
		bool globalOnly;
};

//-------------------------------------------------------------------------------------------------------

class PrefsWindow : public BWindow 
{
	public:
		PrefsWindow( BRect frame, bool globalOnly = false ); 
		virtual	bool QuitRequested();
		virtual void MessageReceived( BMessage *message );
		virtual void DispatchMessage( BMessage* msg, BHandler* handler );
		
	private:
		GenPrefView* genPrefs;
		ConnectionPrefView* conPrefs;
		ChatWindowPrefView* chatPrefs;
};

#endif